#include "stdafx.h"


#include <atlframe.h>
#include <atlctrls.h>
#include <atldlgs.h>
#include <atlfile.h>
#include <atlctrlx.h>

#include "resource.h"

#include "MainDlg.h"

#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")

#include "writercore.h"
#include "jedfile.h"

//Member Function
void CMainDlg::Initialize(){
	#ifdef USE_TBC
	g_wmTBC=RegisterWindowMessage(_T("TaskbarButtonCreated"));
	#endif
	CAtlFile fin;
	if(SUCCEEDED(fin.Create(__targv[1],GENERIC_READ,FILE_SHARE_READ,OPEN_EXISTING))){
		fin.Close();
		filename = __targv[1];
		CmdLine = 1;
		this->PostMessage(WM_COMMAND,BN_CLICKED<<16|IDC_BTN_PRG);
	}else{
		fin.Close();
	}
	SetTimer(1,1000,NULL);
}

LRESULT CMainDlg::OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/){
	int nIDEvent = wParam;
	if(nIDEvent==1){
		if(closetimer){
			closetimer--;
			CString tmp;
			tmp.Format(_T("Close timer: %dsec. Press [Open] to cancel."),closetimer);
			edit1.SetWindowText(tmp);
			this->UpdateWindow();
			if(closetimer==0) this->PostMessage(WM_COMMAND,BN_CLICKED<<16|IDCANCEL);
		}
	}
	return 0;
}

LRESULT CMainDlg::OnDropFiles(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/){
	HDROP hDropInfo = (HDROP)wParam;
	CString fn;
	DragQueryFile(hDropInfo,0,fn.GetBuffer(256),256);
	DragFinish(hDropInfo);
	CAtlFile fin;
	if(SUCCEEDED(fin.Create(fn,GENERIC_READ,FILE_SHARE_READ,OPEN_EXISTING))){
		fin.Close();
		filename = fn;
		this->PostMessage(WM_COMMAND,BN_CLICKED<<16|IDC_BTN_PRG);
	}else{
		fin.Close();
	}
	return 0;
}

#ifdef USE_TBC
LRESULT CMainDlg::OnTBC(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/){
	CoCreateInstance(CLSID_TaskbarList, NULL,
		CLSCTX_ALL,IID_ITaskbarList3, (void**)&ptl);
	THUMBBUTTON buttons[2];
	buttons[0].dwMask = THB_ICON|THB_TOOLTIP|THB_FLAGS;
	buttons[0].iId = 1;
	buttons[0].hIcon = AtlLoadIconImage(IDI_ICN_PRG);
	wcscpy(buttons[0].szTip,_T("Program"));
	buttons[0].dwFlags = THBF_ENABLED;
	buttons[1].dwMask = THB_ICON|THB_TOOLTIP|THB_FLAGS;
	buttons[1].iId = 2;
	buttons[1].hIcon = AtlLoadIconImage(IDI_ICN_ERS);
	wcscpy(buttons[1].szTip,_T("Erase"));
	buttons[1].dwFlags = THBF_ENABLED;
	ptl->ThumbBarAddButtons(this->m_hWnd,2,buttons);
	return 0;
}
#endif

void CMainDlg::Progress(int p){
	#ifdef USE_TBC
	if(0<=(p)) prog1.SetPos(p);
	if(ptl){
		if((p)<0){
			ptl->SetProgressValue(this->m_hWnd,-(p),100);
			ptl->SetProgressState(this->m_hWnd,TBPF_ERROR);
		}else{
			if((p)==0) ptl->SetProgressState(this->m_hWnd,TBPF_NORMAL);
			ptl->SetProgressValue(this->m_hWnd,p,100);
		}
	}
	#else
	if(0<=(p)) prog1.SetPos(p);
	#endif
	this->UpdateWindow();
}

LRESULT CMainDlg::OnBnClickedBtnOpn(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
		if(closetimer){
		closetimer=0;
		edit1.SetWindowText(_T("Close timer canceled."));
		return 0;
	}
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY/* | OFN_CREATEPROMPT*/,
		_T("JEDEC File (*.jed)\0*.jed\0All Files (*.*)\0*.*\0\0"));

	if(dlg.DoModal() == IDOK){
		//CString strMsg;
		//dlg.GetFilePath(filename.GetBuffer(256),256);
		filename.Format(_T("%s"),dlg.m_szFileName);
		//strMsg.Format(_T("t@CF%s"), filename);
		//MessageBox(strMsg);
	}
	edit1.SetWindowText(filename);
	Progress(0);
	return 0;
}

LRESULT CMainDlg::OnBnClickedBtnCls(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CloseDialog(0);
	return 0;
}

LRESULT CMainDlg::OnBnClickedBtnPrg(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{	
	struct{
		static void Back0(int val, void* ptr){ CString tmp; tmp.Format(_T("IDCODE OK. Erasing... (%3d%%)"),val); ((CMainDlg*)ptr)->edit1.SetWindowText(tmp); ((CMainDlg*)ptr)->Progress(val*20/100+10); }
		static void Back1(int val, void* ptr){ CString tmp; tmp.Format(_T("Erase complete, writing... (%3d%%)"),val); ((CMainDlg*)ptr)->edit1.SetWindowText(tmp); ((CMainDlg*)ptr)->Progress(val*45/100+30); }
		static void Back2(int val, void* ptr){ CString tmp; tmp.Format(_T("Write complete, verifying... (%3d%%)"),val); ((CMainDlg*)ptr)->edit1.SetWindowText(tmp); ((CMainDlg*)ptr)->Progress(val*25/100+75); }
	}Call;

	PUCHAR fuses=NULL;
	DWORD usercode=0xFFFFFFFF,idcode;
	int bitlen,fCL=CmdLine;
	CWaitCursor cwc;

	for(int i=0;i<4;i++) button[i].EnableWindow(0);
	Progress(0);

	CmdLine=0;	
	DWORD t0,t1;
	t0 = timeGetTime();
	
	edit1.SetWindowText(_T("File (re)loading..."));
	this->UpdateWindow();

	try{
		DecodeJedFile(filename, fuses, bitlen, usercode);
		edit1.SetWindowText(_T("File loaded. Detecting IDCODE..."));
		Progress(5);

		if(false==Writer_Open()) throw _T("Could not open JTAG cable.");
		idcode = Writer_GetIdcode();
		edit1.SetWindowText(_T("IDCODE OK. Erasing..."));
		Progress(10);

		Writer_Erase(idcode, Call.Back0, this);
		edit1.SetWindowText(_T("Erase complete, writing..."));
		this->UpdateWindow();

		Writer_Write(idcode, fuses, usercode, Call.Back1, this, bitlen);
		edit1.SetWindowText(_T("Write complete, verifying..."));
		this->UpdateWindow();

		Writer_Verify(idcode, fuses, usercode, Call.Back2, this, bitlen);
		t1 = timeGetTime();
		CString tmp;
		tmp.Format(_T("Program success. (%d.%03dsec)"),(t1-t0)/1000,(t1-t0)%1000);
		edit1.SetWindowText(tmp);
		this->UpdateWindow();
		if(fCL) closetimer=4;

	}catch(LPCTSTR c){
		edit1.SetWindowText(c);
		Progress(-50);
	}catch(CString &s){
		edit1.SetWindowText(s);
		Progress(-50);
	}
	delete[] fuses;
	Writer_Close();
	for(int i=0;i<4;i++) button[i].EnableWindow(1);
	return 0;
}

LRESULT CMainDlg::OnBnClickedBtnErs(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	struct{
		static void Back0(int val, void* ptr){ CString tmp; tmp.Format(_T("IDCODE OK. Erasing... (%3d%%)"),val); ((CMainDlg*)ptr)->edit1.SetWindowText(tmp); ((CMainDlg*)ptr)->Progress(val*95/100+5); }
	}Call;

	DWORD idcode;
	DWORD t0,t1;
	t0 = timeGetTime();
	
	CWaitCursor cwc;
	for(int i=0;i<4;i++) button[i].EnableWindow(0);
	Progress(0);

	if(false==Writer_Open()){
		edit1.SetWindowText(_T("Could not open JTAG cable."));
		Progress(-50);
		for(int i=0;i<4;i++) button[i].EnableWindow(1);
		return 0;
	}

	try{
		idcode = Writer_GetIdcode();
		edit1.SetWindowText(_T("IDCODE OK. Erasing..."));
		Progress(5);

		Writer_Erase(idcode, Call.Back0, this);
		
		t1 = timeGetTime();
		CString tmp;
		tmp.Format(_T("Erase success. (%d.%03dsec)"),(t1-t0)/1000,(t1-t0)%1000);
		edit1.SetWindowText(tmp);
		this->UpdateWindow();

	}catch(LPCTSTR c){
		edit1.SetWindowText(c);
		Progress(-50);
	}catch(CString &s){
		edit1.SetWindowText(s);
		Progress(-50);
	}
	Writer_Close();
	for(int i=0;i<4;i++) button[i].EnableWindow(1);
	return 0;
}
