#include "stdafx.h"	//For MFC. This can be removed.

#include <windows.h>

#include "_mpusbapi.h"

#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")

#define OVLP 128	//Overrapped input

struct handler{
	HANDLE hw,hr;
	DWORD tw,tr;
	DWORD rcvd;
	DWORD amari[64];
	UCHAR buf[OVLP][64];
	OVERLAPPED ovl[OVLP];
	DWORD nob[OVLP];	//number of bytes
	DWORD crb;			//current read buffer
	DWORD err;
};

void UO_Close(HANDLE h){
	if(h==0 || h==INVALID_HANDLE_VALUE) return;
	handler* han=(handler*)h;
	if(!han->err){
		CancelIo(han->hr);
	}
	for(int i=0;i<OVLP;i++){
		WaitForSingleObject(han->ovl[han->crb].hEvent,0);
		han->crb++;
		if(OVLP <= han->crb) han->crb=0;
	}
	MPUSBClose(han->hr);
	MPUSBClose(han->hw);
	for(int i=0;i<OVLP;i++) CloseHandle(han->ovl[i].hEvent);
	delete han;
}

HANDLE UO_Open(PCHAR vidpid="vid_09fb&pid_6001"){
	handler* h=new handler;
	h->hw=MPUSBOpen(0,vidpid,"\\MCHP_EP2",MP_WRITE,0);
	h->hr=MPUSBOpen(0,vidpid,"\\MCHP_EP1",MP_READ,0);
	h->tr=1000;
	h->tw=1000;
	h->rcvd=0;
	if(h->hw==INVALID_HANDLE_VALUE || h->hr==INVALID_HANDLE_VALUE){
		MPUSBClose(h->hr);
		MPUSBClose(h->hw);
		delete h;
		return INVALID_HANDLE_VALUE;
	}
	for(int i=0;i<OVLP;i++){
		h->ovl[i].Offset=0;
		h->ovl[i].OffsetHigh=0;
		h->ovl[i].hEvent=CreateEvent(NULL,FALSE,FALSE,NULL);
		ReadFile(h->hr,h->buf[i],64,&(h->nob[i]),&(h->ovl[i]));
	}
	h->crb=0;
	h->err=0;
	return h;
}

int UO_Write(HANDLE h,PVOID buf,DWORD len,PDWORD cnt){
	if(h==0 || h==INVALID_HANDLE_VALUE) return false;
	handler* han=(handler*)h;
	DWORD bc, skipcnt=0;
	int ret;
	while(1){
		if(WAIT_OBJECT_0==WaitForSingleObject(han->ovl[han->crb].hEvent,0)){
			int ret = GetOverlappedResult(han->hr,&(han->ovl[han->crb]),&bc,FALSE);
			if(!ret){
				han->err++;
				DEBUG_PRINTF(_T("uodrv: RxFailed.\n"));
				return false;
			}
			if(2<bc){
				if(skipcnt) DEBUG_PRINTF(_T("uodrv: SkipRxBuf %dpkt\n"),skipcnt);
				SetEvent(han->ovl[han->crb].hEvent);
				break;
			}
			skipcnt++;
			han->ovl[han->crb].Offset=0;
			han->ovl[han->crb].OffsetHigh=0;
			ResetEvent(han->ovl[han->crb].hEvent);
			ReadFile(han->hr,han->buf[han->crb],64,&(han->nob[han->crb]),&(han->ovl[han->crb]));
			han->crb++;
			if(OVLP <= han->crb) han->crb=0;
		}else{
			if(skipcnt) DEBUG_PRINTF(_T("uodrv: SkipRxBuf %dpkt\n"),skipcnt);
			break;
		}
	}
	if(MPUSB_SUCCESS==MPUSBWrite(han->hw,buf,len,cnt,han->tw)){
		ret=true;
	}else{
		han->err++;
		DEBUG_PRINTF(_T("uodrv: TxFailed.\n"));
		ret=false;
	}
	return ret;
}

int UO_Read(HANDLE h,PVOID buf,DWORD len,PDWORD cnt){
	if(h==0 || h==INVALID_HANDLE_VALUE) return false;
	handler* han=(handler*)h;
	DWORD bc,t0;
	t0=timeGetTime();
	if(han->rcvd){
		memcpy(buf,han->amari,han->rcvd);
	}
	while(1){
		if(WAIT_OBJECT_0==WaitForSingleObject(han->ovl[han->crb].hEvent,10)){
			//data arrive
			int ret = GetOverlappedResult(han->hr,&(han->ovl[han->crb]),&bc,FALSE);
			if(!ret){
				han->err++;
				DEBUG_PRINTF(_T("uodrv: RxFailed.\n"));
				return false;
			}
			if(2<bc){
				DEBUG_PRINTF(_T("uodrv: RxPkt %dbytes\n"),bc);
				if(len<=(han->rcvd+bc-2)){
					memcpy((PCHAR)buf+han->rcvd,han->buf[han->crb]+2,len-han->rcvd);
					memcpy(han->amari,han->buf[han->crb]+2+len-han->rcvd,han->rcvd+bc-2-len);
					han->rcvd=han->rcvd+bc-2-len;
					*cnt=len;
					han->ovl[han->crb].Offset=0;
					han->ovl[han->crb].OffsetHigh=0;
					ResetEvent(han->ovl[han->crb].hEvent);
					ReadFile(han->hr,han->buf[han->crb],64,&(han->nob[han->crb]),&(han->ovl[han->crb]));
					han->crb++;
					if(OVLP <= han->crb) han->crb=0;
					return true;
				}
				memcpy((PCHAR)buf+han->rcvd,han->buf[han->crb]+2,bc-2);
				han->rcvd+=bc-2;
			}
			han->ovl[han->crb].Offset=0;
			han->ovl[han->crb].OffsetHigh=0;
			ResetEvent(han->ovl[han->crb].hEvent);
			ReadFile(han->hr,han->buf[han->crb],64,&(han->nob[han->crb]),&(han->ovl[han->crb]));
			han->crb++;
			if(OVLP <= han->crb) han->crb=0;
		}
		if(han->tr<(timeGetTime()-t0)){
			*cnt=han->rcvd;
			han->rcvd=0;
			DEBUG_PRINTF(_T("uodrv: RxTimeout.\n"),bc);
			return true;
		}
	}
}

void UO_Purge(HANDLE h){
	if(h==0 || h==INVALID_HANDLE_VALUE) return;
	DWORD bc;
	handler* han=(handler*)h;
	while(1){
		if(WAIT_OBJECT_0==WaitForSingleObject(han->ovl[han->crb].hEvent,4)){
			GetOverlappedResult(han->hr,&(han->ovl[han->crb]),&bc,FALSE);
			han->ovl[han->crb].Offset=0;
			han->ovl[han->crb].OffsetHigh=0;
			ResetEvent(han->ovl[han->crb].hEvent);
			ReadFile(han->hr,han->buf[han->crb],64,&(han->nob[han->crb]),&(han->ovl[han->crb]));
			DEBUG_PRINTF(_T("uodrv: Purge %dbytes\n"),bc);
			han->crb++;
			if(OVLP <= han->crb) han->crb=0;
		}else{
			break;
		}
	}
	han->rcvd=0;
}
